%define major 0
%define libname %mklibname nfsidmap %{major}
%define devname %mklibname nfsidmap -d

Summary:	The utilities for Linux NFS server
Name:		nfs-utils
Epoch:		1
Version:	2.2.1
Release:	3
License:	GPLv2+
Group:		Networking/Other
Url:		http://sourceforge.net/projects/nfs/
Source0:	http://prdownloads.sourceforge.net/nfs/%{name}-%{version}.tar.xz
Source3:	nfs-utils_env.sh
Source4:	lockd.conf
Source5: 	24-nfs-server.conf
Source9:	id_resolver.conf
Source10:	nfs.sysconfig
Patch100:	nfs-utils-1.2.1-statdpath-man.patch
Patch101:	nfs-utils-1.2.1-exp-subtree-warn-off.patch
Patch103:	nfs-utils-1.2.5-idmap-errmsg.patch
Patch104:	nfs-utils-2.1.1-nfs-config.patch
#Patch105:	nfs-utils-2.2.1-mountstats-term.patch
Patch106:	nfs-utils-2.2.2-rc2.patch
Patch107:	nfs-utils-2.3.1-systemd-gssproxy-restart.patch
BuildRequires:	keyutils-devel
BuildRequires:	libcap-devel
BuildRequires:	openldap-devel
BuildRequires:	tcp_wrappers-devel
BuildRequires:	pkgconfig(blkid)
BuildRequires:	pkgconfig(devmapper)
BuildRequires:	pkgconfig(krb5)
BuildRequires:	pkgconfig(libevent)
BuildRequires:	pkgconfig(librpcsecgss) >= 0.12
BuildRequires:	pkgconfig(libtirpc)
BuildRequires:	pkgconfig(mount)
Requires:	gssproxy >= 0.7.0
Requires:	rpcbind
Requires:	tcp_wrappers
Requires(pre,post,preun,postun):	rpm-helper

%description
This package provides various programs needed for NFS support on server.

%files
%{_docdir}/%{name}
%dir %{_localstatedir}/lib/nfs
%dir %{_localstatedir}/lib/nfs/v4recovery
%dir %{_localstatedir}/lib/nfs/rpc_pipefs
%dir %{_sysconfdir}/exports.d
%dir %attr(700,rpcuser,rpcuser) %{_localstatedir}/lib/nfs/statd
%dir %attr(700,rpcuser,rpcuser) %{_localstatedir}/lib/nfs/statd/sm
%dir %attr(700,rpcuser,rpcuser) %{_localstatedir}/lib/nfs/statd/sm.bak
%ghost %attr(644,rpcuser,rpcuser) %{_localstatedir}/lib/nfs/statd/state
%config(noreplace) %{_localstatedir}/lib/nfs/etab
%config(noreplace) %{_localstatedir}/lib/nfs/rmtab
%config(noreplace) %{_sysconfdir}/request-key.d/id_resolver.conf
%config(noreplace) %{_sysconfdir}/modprobe.d/lockd.conf
%config(noreplace) %{_sysconfdir}/exports
%config(noreplace) %{_sysconfdir}/sysconfig/nfs
%config(noreplace) %{_sysconfdir}/nfsmount.conf
%attr(0600,root,root) %config(noreplace) /%{_sysconfdir}/gssproxy/24-nfs-server.conf
%attr(755,root,root) /usr/libexec/nfs-utils/nfs-utils_env.sh
%{_unitdir}/auth-rpcgss-module.service
%{_unitdir}/nfs-blkmap.service
%{_unitdir}/nfs-config.service
%{_unitdir}/nfs-idmap.service
%{_unitdir}/nfs-idmapd.service
%{_unitdir}/nfs-lock.service
%{_unitdir}/nfs-mountd.service
%{_unitdir}/nfs-secure.service
%{_unitdir}/nfs-server.service
%{_unitdir}/nfs-utils.service
%{_unitdir}/nfs.service
%{_unitdir}/rpc-gssd.service
%{_unitdir}/rpc-statd-notify.service
%{_unitdir}/rpc-statd.service
%{_unitdir}/nfs-client.target
%{_unitdir}/rpc_pipefs.target
%{_unitdir}/proc-fs-nfsd.mount
%{_unitdir}/var-lib-nfs-rpc_pipefs.mount
/sbin/nfsddebug
/sbin/mount.nfs
/sbin/mount.nfs4
/sbin/umount.nfs
/sbin/umount.nfs4
/sbin/rpcdebug
/sbin/nfsdebug
/sbin/osd_login
/sbin/nfsdcltrack

/lib/systemd/system-generators/nfs-server-generator
/lib/systemd/system-generators/rpc-pipefs-generator
%{_sbindir}/exportfs
%{_sbindir}/rpc.mountd
%{_sbindir}/rpc.statd
%{_sbindir}/rpc.nfsd
%{_sbindir}/sm-notify
%{_sbindir}/start-statd
%{_sbindir}/showmount
%{_sbindir}/mountstats
%{_sbindir}/nfsiostat
%{_sbindir}/nfsidmap
%{_sbindir}/blkmapd
%{_sbindir}/nfsstat
%{_sbindir}/rpc.idmapd
%{_sbindir}/rpc.gssd
%{_mandir}/man5/exports.5*
%{_mandir}/man5/nfs.5*
%{_mandir}/man5/nfsmount.conf.5*
%{_mandir}/man5/nfs.conf.5*
%{_mandir}/man7/nfsd.7*
%{_mandir}/man7/nfs.systemd.7*
%{_mandir}/man8/exportfs.8*
%{_mandir}/man8/mountd.8*
%{_mandir}/man8/nfsd.8*
%{_mandir}/man8/rpc.mountd.8*
%{_mandir}/man8/rpc.nfsd.8*
%{_mandir}/man8/mount.nfs.8*
%{_mandir}/man8/rpc.sm-notify.8*
%{_mandir}/man8/sm-notify.8*
%{_mandir}/man8/umount.nfs.8*
%{_mandir}/man8/rpc.statd.8*
%{_mandir}/man8/statd.8*
%{_mandir}/man8/showmount.8*
%{_mandir}/man8/nfsstat.8*
%{_mandir}/man8/rpcdebug.8*
%{_mandir}/man8/mountstats.8*
%{_mandir}/man8/nfsiostat.8*
%{_mandir}/man8/nfsidmap.8*
%{_mandir}/man8/blkmapd.8*
%{_mandir}/man8/rpc.gssd.8*
%{_mandir}/man8/rpc.idmapd.8*
%{_mandir}/man8/gssd.8*
%{_mandir}/man8/idmapd.8*
%{_mandir}/man8/nfsdcltrack.8*

%pre
%_pre_useradd rpcuser %{_localstatedir}/lib/nfs /bin/false

%postun
%_postun_userdel rpcuser

#----------------------------------------------------------------------------

%package -n libnfsidmap
Summary:	NFSv4 User and Group ID Mapping library files
License:	BSD
Group:		Networking/Other
Requires:	openldap
Conflicts:	%{_lib}nfsidmap0 < 1:2.2.1
Conflicts:	nfs-utils < 1:2.2.1

%description -n libnfsidmap
Support files for the library that handles mapping between names
and ids for NFSv4.

%files -n libnfsidmap
%doc support/nfsidmap/AUTHORS support/nfsidmap/README support/nfsidmap/COPYING
%config(noreplace) %{_sysconfdir}/idmapd.conf
%{_libdir}/libnfsidmap/*.so
%{_mandir}/man3/nfs4_uid_to_name.3*
%{_mandir}/man5/idmapd.conf.5*

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	NFSv4 User and Group ID Mapping shared library
License:	BSD
Group:		System/Libraries
Requires:	libnfsidmap

%description -n %{libname}
Library that handles mapping between names and ids for NFSv4.

%files -n %{libname}
%{_libdir}/libnfsidmap.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for the libnfsidmap library
Group:		Development/Other
Requires:	%{libname} = %{EVRD}
Conflicts:	%{_lib}nfsidmap0-devel < 1:2.2.1
Obsoletes:	%{_lib}nfsidmap0-devel < 1:2.2.1

%description -n %{devname}
This package includes header files and libraries necessary for
developing programs which use the libnfsidmap library.

%files -n %{devname}
%{_libdir}/pkgconfig/libnfsidmap.pc
%{_includedir}/nfsidmap.h
%{_libdir}/libnfsidmap.so

#----------------------------------------------------------------------------

%prep
%setup -q
%apply_patches

%build
autoreconf -fi
%serverbuild
%configure2_5x \
	LDFLAGS="-pie" \
	--with-statdpath=%{_localstatedir}/lib/nfs/statd \
	--with-statduser=rpcuser \
	--enable-nfsv4 \
	--enable-ipv6 \
	--enable-gss \
	--enable-tirpc \
	--with-krb5=%{_prefix} \
	--enable-mountconfig \
	--enable-libmount-mount \
	--with-pluginpath=%{_libdir}/libnfsidmap \
	--with-systemd \
	--disable-static

make all CFLAGS="%{optflags} -DDEBUG -D_FILE_OFFSET_BITS=64"

%install
install -d %{buildroot}{/sbin,/usr/sbin}
install -d %{buildroot}%{_mandir}/{man5,man8}


%make \
	DESTDIR=%{buildroot} \
	MANDIR=%{buildroot}%{_mandir} \
	SBINDIR=%{buildroot}%{_prefix}/sbin \
	install

install -m 755 tools/rpcdebug/rpcdebug %{buildroot}/sbin/
ln -snf rpcdebug %{buildroot}/sbin/nfsdebug
ln -snf rpcdebug %{buildroot}/sbin/nfsddebug

install -d %{buildroot}%{_sysconfdir}
install -m 644 utils/mount/nfsmount.conf %{buildroot}%{_sysconfdir}

install -d %{buildroot}/usr/libexec/nfs-utils
install -m 755 %{SOURCE3} %{buildroot}/usr/libexec/nfs-utils/nfs-utils_env.sh

install -d %{buildroot}%{_sysconfdir}/request-key.d
install -m 644 %{SOURCE9} %{buildroot}%{_sysconfdir}/request-key.d

install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 %{SOURCE10} %{buildroot}%{_sysconfdir}/sysconfig/nfs

install -d %{buildroot}%{_unitdir}

install -d %{buildroot}%{_localstatedir}/lib/nfs/rpc_pipefs


install -d %{buildroot}%{_localstatedir}/lib/nfs/statd/sm
install -d %{buildroot}%{_localstatedir}/lib/nfs/statd/sm.bak
install -d %{buildroot}%{_localstatedir}/lib/nfs/v4recovery
install -d %{buildroot}%{_sysconfdir}/exports.d
install -d %{buildroot}%{_sysconfdir}/modprobe.d
install -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/modprobe.d/lockd.conf
install -d %{buildroot}%{_sysconfdir}/gssproxy
install -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/gssproxy/24-nfs-server.conf
install -m 644 ./support/nfsidmap/idmapd.conf %{buildroot}%{_sysconfdir}

mv %{buildroot}/usr/lib/systemd/* %{buildroot}/lib/systemd/

#
# For backwards compatablity.
#
cd %{buildroot}%{_unitdir}
ln -s nfs-server.service nfs.service
ln -s rpc-gssd.service nfs-secure.service
ln -s nfs-idmapd.service  nfs-idmap.service
ln -s rpc-statd.service nfs-lock.service

# nuke dupes
rm -f %{buildroot}%{_sbindir}/rpcdebug

cat >%{buildroot}%{_sysconfdir}/exports <<EOF
# /etc/exports: the access control list for filesystems which may be exported
#               to NFS clients.  See exports(5).
EOF

# manage documentation manually
install -d -m 755 %{buildroot}%{_docdir}/%{name}

# fix perms
chmod 0755 %{buildroot}/sbin/mount.nfs


%changelog

* Tue Jan 30 2018 Andrey Bondrov <andrey.bondrov@rosalab.ru> 1:2.2.1-3
- (5ceaf9c) Use libcap-devel instead of pkgconfig(libcap) in BuildRequires


